<?php
/*
This file is part of Thomas Bley's moregroupware
webmail2/calendar2/admin2 module. (tb-mgw)

More information:
-----------------

Simple Groupware Solutions Thomas Bley
Fichtenstr. 23
Germany, 85640 Putzbrunn
Modified by: Gastn Arimn

Contact:
--------

info@simple-groupware.de

http://www.simple-groupware.de


Copyright 2002-2003 Thomas Bley
tb-mgw is distributed under the terms of the GNU General Public
License 

tb-mgw is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

tb-mgw is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with tb-mgw; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
02111-1307  USA
*/

// calendar2_func
// Moregroupware.org

function DrawMonthCalendar($year, $month, $size="small")
{
	/* 
	Draw a month calendar.
	The size and the form of the events are show is
	determined for the $size parameter 
	*/
	
	global $unix_time;
	global $week_start_day; //The day of the week in a firs column of the caledar
	global $today_today; //The actula day in Ymd format
	global $master_array; //Mark the days with events
	global $this_day, $this_month, $this_year; //For mark the selected day in day view
	global $daysofweekreallyshort_lang; //The first leter of the name of the week days
	global $hashmap; //The contents of the languaje files
	global $current_view; //The type of view
	global $all_cals; //Information about events
	global $month_event_lines; //The number of lines shows in the event description
	
	//De Month to draw
	$minical_month = $month;
	$minical_year = $year;
	$first_of_month = $minical_year.$minical_month."01";
	$minical_date = strtotime2($first_of_month);
	//Today
	$start_today_week = dateOfWeek($today_today, $week_start_day);
	//Date of worg
	$this_this = $this_year.$this_month.$this_day;
	$start_this_day_week = dateOfWeek($this_this, $week_start_day);
	//Previous and Next Month
	$previous_month = date("Ymd",strtotime2("-1 month", $minical_date));
	$next_month = date("Ymd",strtotime2("+1 month", $minical_date));

	/*
	Set de form of the calendar
	depending the size parameter.
	Set variable for this properties.
	*/
	
	switch ($size) {
	case "small":
		$calendar_table = 'width="170" border="0" cellpadding="0" cellspacing="0" class="calborder"';
		$previous_month_cell = 'width="1" align="left" valign="top" class="sideback"';
		$previous_month_detail = '<img src="templates/default/media/spacer.gif" width="1" height="20" alt=" ">';
		$month_cell = 'align="center" class="sideback"';
		$month_link = 'class="ps3" href="month.php?getdate='.$first_of_month.'&'.SID.'"';
		$month_font = 'class="G10BOLD"';
		$next_month_cell = 'width="1" align="right" valign="top" class="sideback"';
		$next_month_detail = '<img src="templates/default/media/spacer.gif" width="1" height="20" alt=" ">';
		$days_table = 'border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF"';
		$days_of_week_cell = 'align="center" class="G10BOLD"';
		$free_cell = '';
		$days_of_week_font = '';
		$days_of_week_font_end = '';
		$days_minical_month_font = 'class="G10G"';
		$days_cell = 'align="center" class="G10B"';
		$days_minical_month_cell = '';
		$days_other_month_cell = '';
		$week_number_cell = 'align="center"';
		$week_number_font = '<font class="V9G">';
		$week_number_font_end = '</font>';
		$day_event_style = 'style="font-weight: bold;"';
		break;
	case "medium":
		$calendar_table = 'border="0" cellspacing="0" cellpadding="0" class="calborder"';
		$previous_month_cell = 'width="1" align="left" valign="top" class="sideback"';
		$previous_month_detail = '<img src="templates/default/media/spacer.gif" width="1" height="20" alt=" ">';
		$month_cell = 'align="center" class="sideback"';
		$month_link = 'class="ps3" href="month.php?getdate='.$first_of_month.'&'.SID.'"';
		$month_font = 'class="G10BOLD"';
		$next_month_cell = 'width="1" align="right" valign="top" class="sideback"';
		$next_month_detail = '<img src="templates/default/media/spacer.gif" width="1" height="20" alt=" ">';
		$days_table = 'border="0" cellpadding="0" cellspacing="1" class="yearmonth"';
		$days_of_week_cell = 'width="30" height="14" align="center" class="dateback"';
		$free_cell = 'height="14"';
		$days_of_week_font = '<font class="V9BOLD">';
		$days_of_week_font_end = '</font>';
		$days_minical_month_font = 'class="V9G"';
		$days_cell = 'width="30" height="30" align="right" valign="top"';
		$days_minical_month_cell = 'class="monthreg"';
		$days_other_month_cell = 'class="monthoff"';
		$week_number_cell = 'align="center" width="15" class="dateback"';
		$week_number_font = '<font class="V9G">';
		$week_number_font_end = '</font>';
		$day_event_style = 'style="font-weight: bold;"';
		break; 
	case "big":
		$calendar_table = 'width="749" border="0" cellspacing="0" cellpadding="0" class="calborder"';
		$previous_month_cell = 'align="right" width="40%" class="navback"';
		$previous_month_detail = '<a class="psf" href="month.php?getdate='.$previous_month.'&'.SID.'"><img src="'.IMGPATH.'/left_day.gif" alt="['.$hashmap["last_month_lang"].']" border="0"></a>';
		$month_cell = 'align="center" valign="middle" width="20%" class="navback" nowrap';
		$month_link = '';
		$month_font = 'class="H20"';
		$next_month_cell = 'align="left" width="40%" class="navback"';
		$next_month_detail = '<a class="psf" href="month.php?getdate='.$next_month.'&'.SID.'"><img src="'.IMGPATH.'/right_day.gif" alt="['.$hashmap["next_month_lang"].']" border="0"></a>';
		$days_table = 'border="0" cellpadding="0" cellspacing="1" class="monthback"';
		$days_of_week_cell = 'width="105" height="12" align="center" valign="top" class="dateback"';
		$free_cell = 'height="12"';
		$days_of_week_font = '<font class="V9BOLD">';
		$days_of_week_font_end = '</font>';
		$days_minical_month_font = 'class="G10G"';
		$days_cell = 'width="105" height="105" align="right" valign="top"';
		$days_minical_month_cell = 'class="monthreg"';
		$days_other_month_cell = 'class="monthoff"';
		$week_number_cell = 'width="14" class="dateback"';
		$week_number_font = '';
		$week_number_font_end = '';
		$day_event_style = 'style="font-weight: bold;"';
		break;
	default:
		break;
	}

	//Create the html table for the calendar
	echo "<table $calendar_table> \n";

	//Show the name of month
	echo "<tr> \n";
	echo "<td $previous_month_cell> $previous_month_detail </td> \n";
	echo "<td $month_cell><a $month_link><font $month_font>".localizeDate($hashmap["dateFormat_month"], $minical_date)."</font></a></td> \n";
	echo "<td $next_month_cell> $next_month_detail </td> \n";
	echo "</tr> \n";
	
	//Create a Cell to put a days table.
	echo "<tr> \n";
	echo "<td colspan=\"3\" bgcolor=\"#FFFFFF\" align=\"center\"> \n";
	
	//Create de table for the days
    echo "<table $days_table> \n";
	if ($size == "small") {
		echo "<tr>";
		for ($i=0; $i<7; $i++) {
			echo "<td><img src=\"templates/default/media/spacer.gif\" width=\"21\" height=\"3\" alt=\" \"></td>";
		}
		echo "</tr>";
	}

	//Draw name of name of week days
	echo "<tr>";
	echo "<td $free_cell> </td>";
	$start_day = strtotime2($week_start_day);
	for ($i=0; $i<7; $i++) {
		$day_num = date("w", $start_day);
		$day = daysOfWeekName($day_num, $size);
		echo "<td $days_of_week_cell> $days_of_week_font $day</td>\n";
		$start_day = strtotime2("+1 day", $start_day);
	}
	echo "</tr>";
	if ($size == "small") {
		echo "<tr height=\"3\"> \n";
		echo "<td colspan=\"8\"><img src=\"templates/default/media/spacer.gif\" width=\"1\" height=\"3\" alt=\" \"></td> \n";
		echo "</tr> \n";
	}

    //Draw the part of days
	$start_day = strtotime2(dateOfWeek($first_of_month, $week_start_day));
    $start_week = date("Ymd", $start_day);
	$i = 0;
	$whole_month = TRUE;
	$num_of_events = 0;
	
	do {
		$day = date ("j", $start_day);
		$day2 = date ("d", $start_day);
		$minical_week = date("W", $start_day);
                                        
		$style = "";
		//For Mark today week
		if ($start_week == $start_today_week) {
			$style='style="background-color: #C0FFC0"';
		}
		//For Mark selected week in day or month view
		if (($start_week == $start_this_day_week) && (($current_view == "week") OR ($current_view == "day"))) {
			$style='style="background-color: #C0C0FF"';
		}

        $daylink = date("Ymd", $start_day);
                                    
		$theclass = "psf";
		//For Mark today
		if ($today_today == $daylink) {
			$theclass = "psf2";
		}
		
		//For Mark selected day in day view
		if (($this_this == $daylink) && ($current_view == "day")) {
			$theclass = "psf3";
		}
		
		//For day of the other month view in grey
		$check_month = date ("m", $start_day);
		if ($check_month == $minical_month) {
			$days_cell_class = $days_minical_month_cell;
		} else {
			$day= "<font $days_minical_month_font>$day</font>";
			$days_cell_class = $days_other_month_cell;
		}
		
		//For Mark the days with events
		$event_table = "";
		$event_table_end = "";
		$image1 = "";
		$image2 = "";
		if (isset($master_array[("$daylink")]) && abs($check_month-$minical_month)<=1) {
			$event_style = $day_event_style;
			if ($size == "medium") {
				foreach ($master_array[("$daylink")] as $event_times) {
					foreach ($event_times as $val) {
						if (!isset($val["event_start"])) { 
							$image1 = '<img src="'.IMGPATH.'/allday_dot.gif" alt=" " width="11" height="10" border="0">';
						} else {
							$image2 = '<img src="'.IMGPATH.'/event_dot.gif" alt=" " width="11" height="10" border="0">';
						}
					}
				}
				$event_table = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"1\">  
								<tr>  
								<td align=\"right\" valign=\"top\" class=\"V9\">";
				$event_table_end = "</td> 
									</tr> 
									<tr>
									<td align=\"center\" valign=\"top\"> $image1 $image2 </td>
									</tr>
									</table>";
			} else if ($size == "big") {
				$event_table = "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"1\">\n
								<tr>\n
								<td align=\"right\" valign=\"top\" class=\"G10B\">\n";
				$event_table_end = "</td>\n
									</tr>\n";
				foreach ($master_array[("$daylink")] as $event_times) {
					foreach ($event_times as $my_key => $val) {
						$num_of_events++;
										
						$event_start 	= @$val["event_start"];
						$event_end 		= @$val["event_end"];
						$event_start 	= date ($_SESSION["MGW"]->settings["timefmt"], @strtotime2 ("$event_start"));
						$event_start2 	= date (str_replace("a","",$_SESSION["MGW"]->settings["timefmt"]), @strtotime2 ("$event_start"));
						$event_end 		= date ($_SESSION["MGW"]->settings["timefmt"], @strtotime2 ("$event_end"));
						$event_text_short = word_wrap($all_cals[$my_key]["summary"], 12, $month_event_lines);

						$dadd = make_dadd($my_key);
						$dadd .= (isset($val["recur"])?build_rep_showmenu($val["recur"],$my_key):"");

						$event_table_end .= "<tr>\n
											<td>\n
											<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n
											<tr style=\"background-color: ".$all_cals[$my_key]["color"].";\">\n";
						if (!isset($val["event_start"])) {
		                	$event_start_full = localizeDate($hashmap["dateFormat_week_list"]." %Y", $unix_time);
							$event_end_full = "";	

							$event_table_end .= "<td onclick=\"window.event.cancelBubble=true;openEventInfo('$my_key','".$all_cals[$my_key]["calendar"]."');\"><font class=\"V10\"><center><a class=\"psf\" href=\"#\" style=\"color:".($all_cals[$my_key]["color"]?"#FFFFFF":"")."\" ".'onmouseover="showmenu(event,\''.get_calendar_display($all_cals[$my_key]["calendar"]).'\',\''.addslashes(tb_htmlentities($all_cals[$my_key]["summary"])).'\',\''.addslashes(tb_htmlentities($all_cals[$my_key]["description"])).'\',\''.addslashes(tb_htmlentities($all_cals[$my_key]["location"])).'\',\''.$all_cals[$my_key]["class"].'\',\''.$all_cals[$my_key]["categories"].'\',\''.$event_start_full.'\',\''.$event_end_full.'\''.$dadd.'); return false;" onmouseout="delayhidemenu()"'."><i>".$event_text_short."</i></a></center></font></td>\n";
						} else {	
                            $start_date_full = localizeDate($hashmap["dateFormat_week_list"]." %Y", $val["start_unixtime"]);
                            $end_date_full = localizeDate($hashmap["dateFormat_week_list"]." %Y", $val["end_unixtime"]);

	                        $event_start_full   = $start_date_full." ".date($_SESSION["MGW"]->settings["timefmt"], $val["start_unixtime"]);
       		                $event_end_full     = date($_SESSION["MGW"]->settings["timefmt"], $val["end_unixtime"]);
               		        if ($start_date_full != $end_date_full) { 
               		        	$event_end_full = $end_date_full." ".$event_end_full; 
               		        }
											
							$event_table_end .= "<td onclick=\"window.event.cancelBubble=true;openEventInfo('$my_key','".$all_cals[$my_key]["calendar"]."')\" align=\"left\" valign=\"top\" ".'onmouseover="showmenu(event,\''.get_calendar_display($all_cals[$my_key]["calendar"]).'\',\''.addslashes(tb_htmlentities($all_cals[$my_key]["summary"])).'\',\''.addslashes(tb_htmlentities($all_cals[$my_key]["description"])).'\',\''.addslashes(tb_htmlentities($all_cals[$my_key]["location"])).'\',\''.$all_cals[$my_key]["class"].'\',\''.$all_cals[$my_key]["categories"].'\',\''.$event_start_full.'\',\''.$event_end_full.'\''.$dadd.'); return false;" onmouseout="delayhidemenu()"'."><a class=\"psf\" href=\"#\"><font class=\"V9\" style=\"color:".($all_cals[$my_key]["color"]?"#FFFFFF":"")."\">&nbsp;$event_start2&nbsp;".$event_text_short."</font></a></td>\n";
						}
						$event_table_end .= "</tr>\n
											</table>\n";
					}
				}
			$event_table_end .= "</table>\n";
			}
		} else {
			$event_style = '';
		}
        
        //Draw the cell with the number of weeks                                
        if ($i == 0) {
        	echo "<tr >";
        	echo "<td $week_number_cell $style><a href='week.php?getdate=".$daylink."&".SID."'class='psf'> $week_number_font".date ("W",$start_day)."$week_number_font_end</a></td>\n";
        }

		//Day cell
		echo "<td $days_cell $days_cell_class onclick=\"window.location.href='day.php?getdate=$daylink&".SID."'\" $style >\n";
		echo $event_table;
		echo "<a class=\"".$theclass."\"href=\"day.php?getdate=$daylink&".SID."\" $event_style >$day</a>\n";
		echo $event_table_end;
		echo "</td>\n";

		//Go to the next day         
		$start_day = strtotime2("+1 day", $start_day); 
		$i++;

		//If the week finish
		if ($i == 7) { 
			echo "</tr>\n";
			$i = 0;
			$checkagain = date("m", $start_day);
			//if the month change, mark for finish
			if ($checkagain != $minical_month) {
				$whole_month = FALSE;
			}    
			$start_week = date("Ymd",$start_day);
		}
	} while ($whole_month == TRUE);

	//Finish the days table
	echo "</table> \n";
	
	//Finish de calendar table
	echo "</td>";
	echo "</tr>";
	if ($size == "small") {
		echo "<tr>";
		echo "<td colspan=\"3\" bgcolor=\"#FFFFFF\"><img src=\"templates/default/media/spacer.gif\" width=\"148\" height=\"6\" alt=\" \"></td>";
		echo "</tr>";
	}
	echo "</table> \n";
	
}

function daysOfWeekName($day, $size)
{
	/*
	Return the Name of week day, 
	acording the namber of day and the size of the calendar
	*/
	
	global $daysofweekreallyshort_lang, $daysofweekshort_lang, $daysofweek_lang; //Days of week names, acording the languaje
	
	switch ($size) {
	case "small":
		$name = $daysofweekreallyshort_lang[$day];
		break;
	case "medium":
		$name = $daysofweekshort_lang[$day];
		break;
	case "big":
		$name = $daysofweek_lang[$day];
		break;
	default:
		$name = "incorrect size";
		break;
	}
	
	return $name;	
		
}

?>
