<?php
/******************************************************************************
 * Datei:				functions.php
 * Autor:				Thorsten Rinne		thorsten@rinne.info
 * Datum:				2001-02-18
 * Letzte nderung:		2003-12-10
 * Copyright:           (c) 2001-2002 Thorsten Rinne und Bastian Pttner
 *                      (c) 2001-2004 Thorsten Rinne
 * 
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 ******************************************************************************/

/*
 * Diese Funktion gibt alle Rubriken und Unterrubriken der bergebenen Rubrik-ID aus | @@ Thorsten, 2002-08-22
 * Last Update: @@ Thorsten, 2003-03-06
 */
function printCategories($rubrik)
{
	global $db, $sids, $sqltblpre, $err_noHeaders;
	$result = $db->query("SELECT rubrik, titel FROM ".$sqltblpre."faqrubrik WHERE LEFT(rubrik, ".strlen($_REQUEST["rubrik"]).") = '".$_REQUEST["rubrik"]."' AND LENGTH(rubrik) > '".strlen($_REQUEST["rubrik"])."' ORDER BY rubrik");
	$output = "";
	if ($db->num_rows($result) > 0) {
		while(list($prubrik, $titel) = $db->fetch_row($result)) {
			$layer = (strlen($prubrik) / 3) - 1;
			for ($h = 1; $h <= $layer; $h++):
				$output .= "\t&nbsp;&nbsp;";
			endfor; 
			$output .= "\t<b></b> <a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=anzeigen&amp;rubrik=".$prubrik."\">".stripslashes($titel)."</a><br />\n";
			}
		}
	else {
		$output .= "\t<b>".$err_noHeaders."</b><br />";
		}
	return $output;
}

/*
 * Diese Funktion gibt alle Rubriken aus | @@ Thorsten, 2002-09-27
 * Contributors:    Krzysztof Kruszynski, 2003-10-24
 * Last Update: @@ Thorsten, 2003-05-04
 */
function printMainCategories ($rubrik = "")
{
	global $db, $sids, $sqltblpre, $err_noHeaders;
	$query = "SELECT rubrik, titel FROM ".$sqltblpre."faqrubrik WHERE LENGTH(rubrik) = '3'";
    for ($s = 3; $s <= strlen($rubrik); $s += 3) {
        $subrubrik = substr($rubrik, 0, $s);
        $query .= " OR (LEFT(rubrik, ".strlen($subrubrik).") = '".$subrubrik."' AND LENGTH(rubrik)=".(strlen($subrubrik) + 3).")";
        }
	$query .= " ORDER BY rubrik";
	$result = $db->query($query);
	$output = "";
	if ($db->num_rows($result) > 0) {
		while (list($prubrik, $titel) = $db->fetch_row($result)) {
			$layer = (strlen($prubrik) / 3) - 1;
			for ($h = 1; $h <= $layer; $h++) {
				$output .= "\t&nbsp;&nbsp;";
				}
			$output .= "<b></b> ";
			if ($rubrik == $prubrik) {
				$output .= "<b>";
				}
			$output .= "<a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=anzeigen&amp;rubrik=".$prubrik."\">".stripslashes($titel)."</a>";
			if ($rubrik == $prubrik) {
				$output .= "</b> ";
				}
			$output .= "<br>\n";
			}
		}
	else {
		$output .= "\t<b>".$err_noHeaders."</b><br />";
		}
	return $output;
}

/*
 * Funktion fr Umwandlung der Artikelnamen | @@ Thorsten, 2002-08-28
 * Last Update: @@ Thorsten, 2003-03-10
 */
function getThema($id, $lang)
{
	global $db, $sqltblpre, $no_cats;
	$query = "SELECT ".$sqltblpre."faqdata.thema FROM ".$sqltblpre."faqdata WHERE id = '".$id."' AND lang = '".$lang."'";
	$result = $db->query($query);
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
			$output = $row->thema;
			}
		}
	else {
		$output = $no_cats;
		}
	return $output;
}

/*
 * Funktion fr die Datumsumwandlung nach ISO 8601 | @@ Thorsten, 2001-04-30
 * Last Update: @@ Thorsten, 2003-10-26
 */
function makeDate($date)
{
	return substr($date,0,4)."-".substr($date,4,2)."-".substr($date,6,2)." ".substr($date,8,2).":".substr($date,10,2);
}

/*
 * Funktion fr die Ausgabe der Anzahl der Artikel in der FAQ | @@ Thorsten, 2002-08-23
 * Last Update: @@ Thorsten, 2003-10-26
 */
function generateNumberOfArticles()
{
	global $db, $msgNoNews, $sqltblpre;
	$num = $db->num_rows($db->query("SELECT id FROM ".$sqltblpre."faqdata WHERE active = 'yes'"));
	if ($num > 0) {
		return "<b>".$num."</b>";
	    }
    else {
        return "<b>0</b>";
		}
}

/*
 * Diese Funktion gibt alle Rubriken und Unterrubriken mit der Anzahl der Artikel aus | @@ Thorsten, 2002-08-27
 * Last Update: @@ Thorsten, 2003-05-20
 */
function printCategoriesPlusNumber()
{
	global $db, $sids, $sqltblpre, $msgEntries, $err_noHeaders;
	
	$result = $db->query("SELECT ".$sqltblpre."faqrubrik.rubrik, ".$sqltblpre."faqrubrik.titel, count(".$sqltblpre."faqdata.rubrik) AS number FROM ".$sqltblpre."faqrubrik LEFT JOIN ".$sqltblpre."faqdata ON ".$sqltblpre."faqdata.rubrik = ".$sqltblpre."faqrubrik.rubrik AND ".$sqltblpre."faqdata.active = 'yes' GROUP BY ".$sqltblpre."faqrubrik.rubrik ORDER BY ".$sqltblpre."faqrubrik.rubrik");
	
	$output = "";
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
			$layer = (strlen($row->rubrik) / 3) - 1;
			for ($h = 1; $h <= $layer; $h++):
				$output .= "\t&nbsp;&nbsp;";
			endfor; 
			$output .= "\t<b></b> <a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=anzeigen&amp;rubrik=".$row->rubrik."\">".$row->titel."</a> (".$row->number." ".$msgEntries.")<br />\n";
			}
		}
	else {
		$output .= "\t<b>".$err_noHeaders."</b><br />";
		}
	
	return $output;
}

/*
 * Diese Funktion gibt alle Themen einer Rubrik aus | @@ Thorsten, 2002-08-27
 * Last Update: @@ Thorsten, 2003-06-14
 */
function printThemes($category)
{
	global $db, $sids, $msgEntries, $msgPage, $msgVoteFrom, $msgPages, $msgViews, $msgPrevious, $msgNext, $err_noArticles, $sqltblpre;
	
	$seite = 1;
	$output = "";
	
	if (isset($_REQUEST["seite"])) {
		$seite = $_REQUEST["seite"];
		}
	
	// get number of entries
	$numResult = $db->query("SELECT id FROM ".$sqltblpre."faqdata WHERE active = 'yes' AND rubrik = '".$category."'");
	$num = $db->num_rows($numResult);
	
	// get number of pages (default: 10 entries per page)
	$seiten = ceil($num / 10);
	if ($seite == 1) {
		$first = 0;
		}
	else {
		$first = $seite * 10 - 10;
		}
	
	$result = $db->query("SELECT ".$sqltblpre."faqdata.id, ".$sqltblpre."faqdata.lang, ".$sqltblpre."faqdata.thema, ".$sqltblpre."faqdata.rubrik, ".$sqltblpre."faqvisits.visits FROM ".$sqltblpre."faqdata LEFT JOIN ".$sqltblpre."faqvisits ON ".$sqltblpre."faqdata.id = ".$sqltblpre."faqvisits.id AND ".$sqltblpre."faqvisits.lang = ".$sqltblpre."faqdata.lang WHERE ".$sqltblpre."faqdata.active = 'yes' AND ".$sqltblpre."faqdata.rubrik = '".$category."' ORDER BY ".$sqltblpre."faqdata.id LIMIT ".$first.", 10");
	$num = $db->num_rows($result);
	
	if ($num > 0) {
		if ($seiten > 1) {
			$output .= "<p><b>".$msgPage.$seite." ".$msgVoteFrom." ".$seiten.$msgPages."</b></p>";
			}
		$output .= "<ul type=\"square\">\n";
        while ($row = $db->fetch_object($result)) {
			if (empty($row->visits)) {
				$visits = "0";
				}
			else {
				$visits = $row->visits;
				}
            $output .= "<li><a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=artikel&amp;rubrik=".$row->rubrik."&amp;id=".$row->id."&amp;lang=".$row->lang."\">".stripslashes($row->thema)."</a> [".$row->lang."]<br><div class=\"little\">(".$visits." ".$msgViews.")</div></li>";
            }
        $output .= "</ul>\n";
        }
    else {
		$output = $err_noArticles;
		}
    
    if ($seiten > 1) {
        $output .= "<p align=\"center\"><b>";
        $previous = $seite - 1; 
        $next = $seite + 1;
        if ($previous != 0) {
            $output .= "[ <a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=anzeigen&amp;rubrik=".$category."&amp;seite=".$previous."\">".$msgPrevious."</a> ]";
            }
        $output .= " ";
        if ($next <= $seiten) {
            $output .= "[ <a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=anzeigen&amp;rubrik=".$category."&amp;seite=".$next."\">".$msgNext."</a> ]";
            }
        $output .= "</b></p>";
		}
	return $output;
}

/*
 * Diese Funktion gibt alle Rubriken und Unterrubriken in <option> aus | @@ Thorsten, 2002-09-16
 * Last Update: @@ Thorsten, 2003-03-28
 */
function printCategoryOptions($rubrik = "")
{
	global $db, $sids, $sqltblpre, $err_noHeaders;
	
	$query = "SELECT rubrik,titel FROM ".$sqltblpre."faqrubrik ORDER BY rubrik;";
	$result = $db->query($query);
	$output = "";
	if ($db->num_rows($result) > 0) {
		while(list($prubrik, $titel) = $db->fetch_row($result)) {
			$layer = (strlen($prubrik) / 3) - 1;
			$output .= "\t\t<option value=\"".$prubrik."\"";
			if ($rubrik == $prubrik) {
				$output .= " selected=\"selected\"";
				}
			$output .= ">";
			for ($h = 1; $h <= $layer; $h++):
				$output .= "&nbsp;&nbsp;";
			endfor; 
			$output .= $titel."</option>\n";
			}
		}
	else {
		$output .= "\t<b>".$err_noHeaders."</b><br />";
		}
	return $output;
}

/*
 * Funktion fr die berprfung von bergebenen Variablen | @@ Thorsten, 2003-01-30
 * Last Update: @@ Thorsten, 2003-01-30
 */
function checkIntVar($myInt)
{
	if (preg_match ("/^[0-9-]+$/", $myInt)) {
    	return TRUE;
		}
	else {
    	return FALSE;
		}
}

/*
 * Check, ob eine weitere Sprache eines Artikels vorhanden ist | @@ Thorsten, 2003-03-17
 * Last Update: @@ Thorsten, 2003-03-17
 */
function check4Language($id)
{
	global $db, $sqltblpre;
	$result = $db->query("SELECT lang FROM ".$sqltblpre."faqdata WHERE id = '".$id."'");
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
			$output[] = $row->lang;
			}
		}
	return $output;
}

/*
 * Gibt "selected zurck", wenn bergebene Variable mit der Sprache des Browsers bereinstimmt | @@ Thorsten, 2003-03-21
 * Last Update: @@ Thorsten, 2003-03-24
 */
function acceptLanguage($articleLang, $lang)
{
	if ($articleLang == $lang) {
		if ($lang == trim(strtolower(substr($_SERVER["HTTP_ACCEPT_LANGUAGE"], 0, 2)))) {
			print " selected=\"selected\"";
			}
		}
}

/*
 * Funktion fuer Umwandlung der <br> in \n | @@ Thorsten, 2001-07-01
 * copyright Johannes Frmter von http://www.koehntopp.de/php
 * Last Update: @@ Thorsten - 2002-09-27
 */
function br2nl($str)
{
	return preg_replace("=<br(>|([\s/][^>]*)>)\r?\n?=i", "\n", $str);
}

/*
 * Funktion fr Umwandlung der E-Mailadressen (Spam!) | @@ Thorsten, 2003-04-17
 * Last Update: @@ Thorsten, 2003-04-17
 */
function safeEmail($email)
{
	return str_replace(array('@', '.'), array(' at ', ' dot '), $email);
}

/*
 * Funktion fr den Syntaxcheck von E-Mails | @@ Thorsten, 2004-01-19
 * Last Update: @@ Thorsten, 2004-01-19
 */
function checkEmail($sender)
{
    $pattern =  "#^[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+".
                "@".
                "[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+\.".
                "[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+$#";
    if (isset($sender) && preg_match($pattern, $sender)) {
        return TRUE;
        }
    else {
        return FALSE;
        }
}


/*
 * Nachbildung der Funktion checkdnsrr() | @@ Thorsten, 2003-04-02
 * Last Update: @@ Thorsten, 2003-04-15
 */
function checkdnsrr4windows($host, $type = "")
{
	if (!empty($host)) {
		if ($type == "") {
			$type = "MX";
			}
		@exec("nslookup -type=".$type." ".$host, $output);
		while (list($k, $line ) = each($output)) {
			if (eregi("^$host", $line)) {
				return true;
				}
			}
		return false;
		}
}



/*
 * Funktion fr Reload-Sperre beim Voting | @@ Thorsten, 2003-05-15
 * Last Update: @@ Thorsten, 2003-05-15
 */
function votingCheck($id, $ip)
{
	global $db, $sqltblpre;
	$timeNow = (time() - 300);
	if ($db->num_rows($db->query("SELECT id FROM ".$sqltblpre."faqvoting WHERE artikel = '".$id."' AND (ip = '".$ip."' AND datum > '".$timeNow."')"))) {
		return FALSE;
		}
	return TRUE;
}



/*
 * Funktion fr IP-Bann | @@ Thorsten, 2003-06-06
 * Last Update: @@ Thorsten, 2003-06-06
 */
function IPCheck($ip)
{
	global $bannedIP;
	$arrBannedIPs = explode(" ", $bannedIP);
	foreach ($arrBannedIPs as $oneIP) {
    	if ($oneIP == $ip) {
			return FALSE;
			}
		}
	return TRUE;
}




/******************************************************************************
 * Funktionen fr das Usertracking
 ******************************************************************************/

/*
 * Trackt den User und zeichnet die Bewegungen auf | @@ Bastian, 2001-02-18
 * Last Update: @@ Thorsten, 2003-11-18
 */
function Tracking($action, $id)
{
	global $db, $tracking, $sid, $sqltblpre;
	if ($tracking) {
		if (isset($_REQUEST["sid"])) {
			$sid = $_REQUEST["sid"];
			}
		if ($action == "oldSession") {
			$sid = "";
			}
		if (strlen($sid) < 2) {
			$db->query("INSERT INTO ".$sqltblpre."faqsessions (IP,TIME) VALUES ('".$_SERVER["REMOTE_ADDR"]."', '".time()."')");
			list($sid) = $db->fetch_row($db->query("SELECT sid FROM ".$sqltblpre."faqsessions ORDER BY sid DESC LIMIT 0,1"));
			}
		$fp = fopen("./data/tracking".date("dmY"), "a");
		$flanz = "0";
		while (!flock($fp, LOCK_EX) && $flanz < 6) {
			sleep(1);
			$flanz++;
			}
		if ($flanz >= 6) {
			fclose($fp);
			}
		elseif (!empty($_SERVER["HTTP_REFERER"])) {
            if (!isset($_SERVER["QUERY_STRING"])) {
                $_SERVER["QUERY_STRING"] = "";
                }
			fputs($fp, $sid.";".str_replace(";", ",",$action).";".$id.";".$_SERVER["REMOTE_ADDR"].";".str_replace(";", ",", $_SERVER["QUERY_STRING"]).";".str_replace(";", ",", $_SERVER["HTTP_REFERER"]).";".str_replace(";", ",", $_SERVER["HTTP_USER_AGENT"]).";".time().";\n");
			flock($fp, LOCK_UN);
			fclose($fp);
			}
		}
}

/*
 * Testet ob die SID zu der IP passt |  @@ Bastian, 2001-04-07
 * Last Update: @@ Thorsten, 2003-03-06
 */
function CheckSID($sid, $ip)
{
	global $db, $sqltblpre;
	if ($db->num_rows($db->query("SELECT sid FROM ".$sqltblpre."faqsessions WHERE sid='".$sid."' AND IP='".$ip."' AND time > ".(time()-86400))) < 1) {
		Tracking("oldSession",$sid);
		}
}

/*
 * Funktion fr Anzeige von Usern, die online sind | @@ Thorsten, 2001-05-02
 * Last Update: @@ Thorsten, 2004-01-21
 */
function userOnline()
{
	global $db, $sqltblpre, $tracking, $msgUserOnline;
	if ($tracking) {
		$timeNow = (time() - 300);
		$result = $db->query("SELECT count(sid) FROM ".$sqltblpre."faqsessions WHERE time > '".$timeNow."' GROUP BY ip");
		if (isset($result)) {
			return $db->num_rows($result)." ".$msgUserOnline;
	        }
		}
}



/******************************************************************************
 * Funktionen fr die Startseite
 ******************************************************************************/

/*
 * Funktion fr die Ausgabe der FAQ-News | @@ Thorsten, 2002-08-23
 * Last Update: @@ Thorsten, 2003-11-07
 */
function generateNews()
{
	global $db, $msgNoNews, $sqltblpre, $numNewsArticles, $ubbcode;
	$result = $db->query("SELECT datum, header, artikel, link, linktitel, target FROM ".$sqltblpre."faqnews ORDER BY datum desc LIMIT 0,".$numNewsArticles);
	$output = "";
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
            if ($ubbcode == "true") {
			    $output .= "<p><b class=\"header\">".$row->header."</b><br />\n".stripslashes(parseUBB($row->artikel))."\n";
                }
            else {
                $output .= "<p><b class=\"header\">".$row->header."</b><br />\n".stripslashes($row->artikel)."\n";
                }
            if ($row->link != "") {
    		    $output .= "<br />Info: <a href=\"http://".$row->link."\" target=\"_".$row->target."\">".$row->linktitel."</a>\n";
    		    }
		    $output .=  "<br /><span style=\"font-size: 10px;\">[".makeDate($row->datum)."]</span></p>\n";
		    flush();
		    }
        return $output;
	    }
    else {
        return $msgNoNews;
		}
}

/*
 * Zeigt die Top Ten an - die zehn am hufigsten besuchten Artikel der FAQ | @@ Thorsten - 2002-05-07
 * Last Update: @@ Thorsten, 2003-03-17
 */
function generateTopTen()
{
	global $db, $sids, $err_noTopTen, $msgViews, $sqltblpre;
	$result = $db->query("SELECT DISTINCT ".$sqltblpre."faqdata.id, ".$sqltblpre."faqdata.lang, ".$sqltblpre."faqdata.thema, ".$sqltblpre."faqdata.rubrik, ".$sqltblpre."faqvisits.visits FROM ".$sqltblpre."faqvisits, ".$sqltblpre."faqdata WHERE ".$sqltblpre."faqdata.id = ".$sqltblpre."faqvisits.id AND ".$sqltblpre."faqdata.lang = ".$sqltblpre."faqvisits.lang AND ".$sqltblpre."faqdata.active = 'yes' ORDER BY ".$sqltblpre."faqvisits.visits DESC LIMIT 0,10");
	$output = "";
	if ($db->num_rows($result) > 0) {
		$i = 1;
		while ($row = $db->fetch_object($result)) {
			$output .= "<tr>\n\t<td class=\"topten\">\n";
			$output .= "\t<b>[".$i.".] ".$row->visits." ".$msgViews.":</b><br /><a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=artikel&amp;rubrik=".$row->rubrik."&amp;id=".$row->id."&amp;lang=".$row->lang."\">".stripslashes(makeShorterText($row->thema, 8))."</a>\n";
			$output .= "\t</td>\n\t</tr>\n";
			$i++;
			}
		}
	else {
		$output = "<tr><td class=\"topten\">".$err_noTopTen."</td></tr>";
		}
	return $output;
}

/*
 * Zeigt die fnf neuesten Artikel an | @@ Thorsten - 2002-05-07
 * Last Update: @@ Thorsten, 2003-04-10
 */
function generateFiveNewest()
{
	global $db, $sqltblpre, $sids, $err_noTopTen, $msgViews;
	$result = $db->query("SELECT DISTINCT ".$sqltblpre."faqdata.id, ".$sqltblpre."faqdata.lang, ".$sqltblpre."faqdata.rubrik, ".$sqltblpre."faqdata.thema, ".$sqltblpre."faqdata.datum, ".$sqltblpre."faqvisits.visits FROM ".$sqltblpre."faqdata, ".$sqltblpre."faqvisits WHERE ".$sqltblpre."faqdata.id = ".$sqltblpre."faqvisits.id AND ".$sqltblpre."faqdata.lang = ".$sqltblpre."faqvisits.lang AND ".$sqltblpre."faqdata.active = 'yes' ORDER BY ".$sqltblpre."faqdata.datum desc LIMIT 0,5");
	
	if ($num = $db->num_rows($result) > 0) {
		$output = "";
		while ($row = $db->fetch_object($result)) {
			$output .= "\t\t<tr>\n";
			$output .= "\t\t\t<td valign=\"top\" class=\"fivenewest\" nowrap>".makeDate($row->datum)."</td>\n";
			$output .= "\t\t\t<td valign=\"top\" class=\"fivenewest\"><a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=artikel&amp;rubrik=".$row->rubrik."&amp;id=".$row->id."&amp;lang=".$row->lang."\">".stripslashes(makeShorterText($row->thema, 8))."</a></td>\n";
			$output .= "\t\t\t<td valign=\"top\" class=\"fivenewest\" nowrap>".$row->visits." ".$msgViews."</td>\n";
			$output .= "\t\t</tr>\n";
			}
		}
	else {
		$output = "<tr class=\"fivenewest\"><td>".$err_noTopTen."</td></tr>";
		}
	return $output;
}

/*
 * Krzt einen String auf eine bestimmte Anzahl von Wrtern | @@ Thorsten - 2002-08-26
 * Last Update: @@ Thorsten, 2003-03-08
 */
function makeShorterText($str, $char)
{
	$str = ereg_replace("[[:space:]]+", " ", $str);
	$arrStr = explode(" ", $str);
	$shortStr = "";
	if (count($arrStr) > $char) {
		for ($j = 0; $j <= $char; $j++) {
			$shortStr .= $arrStr[$j]." ";
			}
		$shortStr .= "...";
		}
	else {
		$shortStr = $str;
		}
	return $shortStr;
}



/******************************************************************************
 * Funktionen fr Artikelseiten
 ******************************************************************************/

/*
 * Funktion fr das Zhlen der Visits | @@ Bastian, 2001-02-15
 * Last Update: @@ Thorsten, 2003-03-30
 */
function logViews($myid, $lang)
{
	global $db, $sids, $sqltblpre;
	$nVisits = "0";
	$heute = time();
	if ($result = $db->query ("SELECT visits FROM ".$sqltblpre."faqvisits WHERE id = '".$myid."' AND lang = '".$lang."'")) {
		list($nVisits) = $db->fetch_row($result);
		}
	if ($nVisits == "0" || $nVisits == "") {
		$db->query ("INSERT INTO ".$sqltblpre."faqvisits (id, lang, visits, last_visit) VALUES ('".$myid."', '".$lang."', '1', '".$heute."')");
		}
	else {
		
		$db->query ("UPDATE ".$sqltblpre."faqvisits SET visits = visits+1, last_visit = '".$heute."' WHERE id = '".$myid."' AND lang = '".$lang."'");
		}
}

/*
 * Macht an den String nen / dran, falls keiner da ist
 * @@ Bastian, 2002-01-06
 */
function EndSlash($string)
{
	if( substr($string, strlen($string)-1, 1) != "/" ) {
		$string .= "/";
		}
	return $string;	
}

/*
 * Gibt die Votings des Artikels aus | @@ Thorsten - 2002-08-29
 * Last Update: @@ Thorsten, 2003-10-17
 */
function generateVoting($id)
{
	global $db, $sqltblpre, $msgVoteFrom, $msgVotings;
	
	$query = "SELECT vote, user FROM ".$sqltblpre."faqvoting WHERE artikel = '".$id."'";
	$result = $db->query($query);
	if ($db->num_rows($result) > 0) {
		list($vote, $user) = $db->fetch_row($result);
		return $output = " ".round(($vote/$user),2)." ".$msgVoteFrom." 5 (".$user." ".$msgVotings.")";
		}
	else {
		return $output = " 0 ".$msgVoteFrom." 5 (0 ".$msgVotings.")";
		}
}

/*
 * Gibt die Kommentare zum Artikel aus | @@ Thorsten - 2002-08-29
 * Last Update: @@ Thorsten, 2003-04-17
 */
function generateComments($id)
{
	global $db, $sqltblpre, $msgCommentBy;
	
	$result = $db->query("SELECT user,email,comment FROM ".$sqltblpre."faqcomments WHERE id = '".$id."'");
	$output = "";
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
			$output .= "<p class=\"comment\">\n";;
			$output .= "<b>".$msgCommentBy."<a href=\"mailto:".safeEmail($row->email)."\">".$row->user."</a>:</b>\n";
			$output .= "<br>".ereg_replace("&lt;br /&gt;","<br />",stripslashes(htmlspecialchars($row->comment)))."\n</p>";
			}
		}
	return $output;
}



/******************************************************************************
 * Funktionen fr den BB-Code-Parser
 ******************************************************************************/

/*
 * Funktion fr Umwandlung der BB-Codes | @@ Thorsten, 2001-07-01
 * Contributors:    Meikel Katzengreis, 2003-02-21
 *                  Nick Georgakis, 2003-08-25
 * Last Update: @@ Thorsten, 2003-10-26
 */
function parseUBB($ret)
{
    $ret = stripslashes($ret);
    $pattern = array(   '{\[b\](.*)\[/b\]}smUi',
                        '{\[u\](.*)\[/u\]}smUi',
                        '{\[i\](.*)\[/i\]}smUi',
                        '{\[ul\](.*)\[/ul\]}smUi',
                        '{\[li\](.*)\[/li\]}smUi',
                        '{\[url=(.*)\](.*)\[/url\]}smUi',
                        '{\[url\](.*)\[/url\]}smUi',
                        '{\[img\](.*)\[/img\]}smUi',
                        '{\[size=(.*)\](.*)\[/size\]}smUi',
                        '{\[color=(.*)\](.*)\[/color\]}smUi',
                        '{\[align=(.*)\](.*)\[/align\]}smUi',
                        '{\[\\\\\]}smUi',
                        '{\[center\](.*)\[/center\]}smUi',
                        '{\[(h[1-6]+)\](.*)\[/\\1\]}smUi',
                        '{\[email\](.*)\[/email\]}smUi',
                        '{\[fimg\](.*)\[/fimg\]}smUi',
                        '{\[fimg desc=(.*)\](.*)\[/fimg\]}smUi',
                        '{\[quote\](.*)\[/quote\]}smUi',
                        '{\[email\](.*)\[/email\]}smUi'
                        );
    
    $replace = array(   '<b>\\1</b>',
                        '<u>\\1</u>',
                        '<i>\\1</i>',
                        '<ul>\\1</ul>',
                        '<li>\\1</li>',
                        '<a href="http://\\1" target="_blank">\\2</a>',
                        '<a href="http://\\1" target="_blank">\\1</a>',
                        '<img src="\\1" border="0">',
                        '<span style="font-size: \\1px;">\\2</span>',
                        '<span style="color: \\1;">\\2</span>',
                        '<div align="\\1">\\2</div>',
                        '\\\\'.'\n',
                        '<div align="center">\\1</div>',
                        '<\\1>\\2</\\1>',
                        '<a href="mailto:\\1">\\1</a>',
                        '<img src="./images/\\1" border="0">',
                        '<img src="./images/\\2" border="0" alt="\\1" onMouseOver="'."self.status='\\1'; return(true);".'" onMouseOut="'."self.status=''; return(true);".'">',
                        '<table width="90%" border="0" cellspacing="2" cellpadding="2" align="center" style="border: 1px dashed black;"><tr><td>Quote:<br />\\1</td></tr></table>',
                        '<a href="http://mailto:\\1">\\1</a>'
                        );
    
    $ret = preg_replace($pattern,$replace,$ret);
    $ret = preg_replace_callback("#\[php\](.*)\[\/php\]#Usi","php_syntax", $ret);
    $ret = preg_replace_callback("#\[code\](.*)\[\/code\]#Usi","code_syntax", $ret);
    $ret = preg_replace_callback("#\[lart=(.*) lang=(.*)]#Usi","internalLink", $ret);
    
    $ret = str_replace('http://http://','http://',$ret);
    return $ret;
}

/*
 * Funktion zum Entfernen von <br /> in Abschnitten zwischen <pr> | @@ Meikel Katzengreis, 2003-02-21
 * Last Update: @@ Thorsten, 2003-07-23
 */
function pre_core ($text)
{
	$text = preg_replace("=<br(>|([\s/][^>]*)>)\r?\n?=i", "\n", $text[1]);
    return $text;
}

/*
 * Funktion zum Entfernen von HTML-Tags bis auf <b>, <i>, <u>, und <a> | @@ Thorsten, 2003-02-23
 * Last Update: @@ Thorsten, 2003-07-17
 */
function safeHTML($html)
{
	$html = stripslashes($html);
	$html = strip_tags($html, "<b><i><u><a>");
	return $html;
}

/*
 * Funktion wandelt HTML Entities zurck | @@ Thorsten, 2003-03-27
 * Last Update: @@ Thorsten, 2003-03-27
 */
function unhtmlentities($html)
{
	$translation_table = get_html_translation_table (HTML_ENTITIES);
	$translation_table = array_flip ($translation_table);
	$content = strtr ($html, $translation_table);
	return preg_replace('/\&\#([0-9]+)\;/me', "chr('\\1')", $content);
}

/*
 * Funktion fr PHP-Syntax-Highlighting | @@ Meikel Katzengreis, 2003-03-31
 * Last Update: @@ Thorsten, 2003-07-23
 */
function php_syntax($output)
{
    $ret = $output[1];
    $ret = wordwrap($ret, 120, "\n", 0);
    $ret = highlight_syntax(unhtmlentities($ret));
    return "<pre>".$ret."</pre>";
}

/*
 * Funktion fr PHP-Syntax-Highlighting | @@ Meikel Katzengreis, 2003-03-31
 * Last Update: @@ Thorsten, 2003-07-23
 */
function highlight_syntax($code)
{
    return ob_highlight_syntax ($code);
}

/*
 * Funktion fr BB-Code | @@ Meikel Katzengreis, 2003-07-23
 * Last Update: @@ Thorsten, 2003-07-23
 */
function code_core ($text)
{
    $text = preg_replace("=<br(>|([\s/][^>]*)>)\r?\n?=i", "\n", $text[1]);
    return $text;
}

/*
 * Funktion fr BB-Code | @@ Meikel Katzengreis, 2003-07-23
 * Last Update: @@ Thorsten, 2004-01-20
 */
function code_syntax($output)
{
    $ret = $output[1];
    $ret = wordwrap($ret, 120, "\n", 0);
    $ret = htmlspecialchars($ret);
    return "<pre>".$ret."</pre>";
}



/*
 * Funktion fr BB-Code | @@ Meikel Katzengreis, 2003-07-23
 * Last Update: @@ Thorsten, 2003-07-23
 */
function ob_highlight_syntax ($code)
{
    ob_start();
    @highlight_string($code);
    $code = ob_get_contents();
    ob_end_clean();
    return $code;
}




/******************************************************************************
 * Funktionen fr den XML-Export
 ******************************************************************************/

/*
 * Gibt die XML-Datei zum Artikel aus | @@ Thorsten - 2002-08-29
 * Last Update: @@ Thorsten, 2003-11-02
 */
function generateXMLExport($id, $lang = "")
{
	$categories = getCategories();
	global $db, $sqltblpre, $msgSeeXMLFile, $version, $metaCharset, $ubbcode;
	$result = $db->query("SELECT id, lang, active, rubrik, keywords, thema, content, author, datum FROM ".$sqltblpre."faqdata WHERE id = '".$id."' AND lang = '".$lang."' AND active = 'yes'");
	$output = "";
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
			if ($ubbcode == "true") {
				$xml_content = wordwrap(parseUBB($row->content));
				}
			else {
				$xml_content = wordwrap($row->content);
				}
			$xml_rubrik = $categories[$row->rubrik];
			$xml_thema = wordwrap($row->thema, 60);
			$xml_keywords = $row->keywords;
			if ($ubbcode == "true") {
				parseUBB($xml_content);
				}
			else {
				stripslashes($xml_content);
				}
			$xml_content = trim(htmlspecialchars(stripslashes(wordwrap($xml_content, 60))));
			$output .= "<!-- make new xml-output -->";
			
			if (is_writeable("./xml/")) {
				$xml_fp = fopen("./xml/artikel.".$row->id.".xml","w");
				$my_xml_output = "<?xml version=\"1.0\" encoding=\"".$metaCharset."\" standalone=\"yes\" ?>\n";
				$my_xml_output .= "<!-- XML-Output by phpMyFAQ ".$version." | Date: ".makeDate(date("YmdHis"))." -->\n";
				$my_xml_output .= "<phpmyfaq xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:NamespaceSchemaLocation=\"http://www.phpmyfaq.de/xml/faqschema.xsd\">\n";
				$my_xml_output .= "\t<article id=\"".$row->id."\">\n";
				$my_xml_output .= "\t<language>".$row->lang."</language>\n";
				$my_xml_output .= "\t<category>".strip_tags(stripslashes($xml_rubrik))."</category>\n";
				if ($xml_keywords) {
					$my_xml_output .= "\t<keywords>".$xml_keywords."</keywords>\n";
					}
				else {
					$my_xml_output .= "\t<keywords />\n";
					}
				$my_xml_output .= "\t<theme>".strip_tags($xml_thema)."</theme>\n";
				$my_xml_output .= "\t<content xmlns=\"http://www.w3.org/TR/REC-html40\">".strip_tags($xml_content)."</content>\n";
				if ($row->author) {
					$my_xml_output .= "\t<author>".$row->author."</author>\n";
					}
				else {
					$my_xml_output .= "\t<author />\n";
					}
				$my_xml_output .= "\t<date>".makeDate($row->datum)."</date>\n";
				$my_xml_output .= "\t</article>\n";
				$my_xml_output .= "</phpmyfaq>";
				fputs($xml_fp, $my_xml_output);
				fclose($xml_fp);
				}
			
			$output .= "
<pre dir=\"ltr\">
<span style=\"color:#ff0000;\">&lt;?xml version=\"1.0\" encoding=\"".$metaCharset."\" standalone=\"yes\" ?&gt;</span>
&lt;!-- XML-Output by phpMyFAQ ".$version." --&gt;
<span style=\"color:#ff0000;\">&lt;phpmyfaq xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:NamespaceSchemaLocation=\"http://www.phpmyfaq.de/xml/faqschema.xsd\"&gt;</span>
<span style=\"color:#ff0000;\">&lt;article id=\"".$row->id."\"&gt;</span>
	<span style=\"color:#ff0000;\">&lt;language&gt;</span>".$row->lang."<span style=\"color:#ff0000;\">&lt;/language&gt;</span>
	<span style=\"color:#ff0000;\">&lt;category&gt;</span>".strip_tags($xml_rubrik)."<span style=\"color:#ff0000;\">&lt;/category&gt;</span>
	<span style=\"color:#ff0000;\">&lt;keywords&gt;</span>".$xml_keywords."<span style=\"color:#ff0000;\">&lt;/keywords&gt;</span>
	<span style=\"color:#ff0000;\">&lt;theme&gt;</span>".strip_tags($xml_thema)."<span style=\"color:#ff0000;\">&lt;/theme&gt;</span>
	<span style=\"color:#ff0000;\">&lt;content xmlns=\"http://www.w3.org/TR/REC-html40\"&gt;</span>".strip_tags($xml_content)."<span style=\"color:#ff0000;\">&lt;/content&gt;</span>
	<span style=\"color:#ff0000;\">&lt;author&gt;</span>".$row->author."<span style=\"color:#ff0000;\">&lt;/author&gt;</span>
	<span style=\"color:#ff0000;\">&lt;date&gt;</span>".makeDate($row->datum)."<span style=\"color:#ff0000;\">&lt;/date&gt;</span>
<span style=\"color:#ff0000;\">&lt;/article&gt;</span>
<span style=\"color:#ff0000;\">&lt;/phpmyfaq&gt;</span>
</pre>";
			if (file_exists("./xml/artikel.".$id.".xml")) {
				$output .= "<p><a href=\"./xml/artikel.".$id.".xml\" target=\"_blank\">".$msgSeeXMLFile."</a></p>";
				}
			}
		}
	return wordwrap($output, 80, "\n", 0);
}

/*
 * Funktion zum Exportieren aller Artikel in eine XML-Datei | @@ Thorsten, 2003-03-03
 * Last Update: @@ Thorsten, 2003-03-24
 */
function generateXMLFile()
{
	global $db, $sqltblpre, $version, $metaCharset, $ubbcode;
	$categories = getCategories();
	
	$result = $db->query("SELECT id, lang, active, rubrik, keywords, thema, content, author, datum FROM ".$sqltblpre."faqdata ORDER BY id");
	if ($db->num_rows($result) > 0) {
		
		$my_xml_output = "<?xml version=\"1.0\" encoding=\"".$metaCharset."\" standalone=\"yes\" ?>\n";
		$my_xml_output .= "<!-- XML-Output by phpMyFAQ ".$version." | Date: ".makeDate(date("YmdHis"))." -->\n";
		$my_xml_output .= "<phpmyfaq xmlns=\"http://www.phpmyfaq.de/phpmyfaq\">\n";
		$xml_fp = fopen("../xml/phpmyfaq.xml","w");
		while ($row = $db->fetch_object($result)) {
			
			if ($ubbcode == "true") {
				$xml_content = wordwrap(parseUBB($row->content));
				}
			else {
				$xml_content = wordwrap(stripslashes($row->content));
				}
			
			$xml_rubrik = $categories[$row->rubrik];
			$xml_thema = wordwrap($row->thema, 60);
			$xml_keywords = $row->keywords;
			if ($ubbcode == "true") {
				parseUBB($xml_content);
				}
			else {
				stripslashes($xml_content);
				}
			$xml_content = trim(htmlspecialchars(stripslashes(wordwrap($xml_content, 60))));
			
			if (is_writeable("../xml/")) {
				$my_xml_output .= "\t<article id=\"".$row->id."\">\n";
				$my_xml_output .= "\t<language>".$row->lang."</language>\n";
				$my_xml_output .= "\t<category>".htmlentities(strip_tags($xml_rubrik))."</category>\n";
				if ($xml_keywords) {
					$my_xml_output .= "\t<keywords>".$xml_keywords."</keywords>\n";
					}
				else {
					$my_xml_output .= "\t<keywords />\n";
					}
				$my_xml_output .= "\t<theme>".strip_tags($xml_thema)."</theme>\n";
				$my_xml_output .= "\t<content xmlns=\"http://www.w3.org/TR/REC-html40\">".strip_tags($xml_content)."</content>\n";
				if ($row->author) {
					$my_xml_output .= "\t<author>".$row->author."</author>\n";
					}
				else {
					$my_xml_output .= "\t<author />\n";
					}
				$my_xml_output .= "\t<date>".makeDate($row->datum)."</date>\n";
				$my_xml_output .= "\t</article>\n\n";
				}
			}
		$my_xml_output .= "</phpmyfaq>";
		fputs($xml_fp, $my_xml_output);
		fclose($xml_fp);
		}
	print "<p><a href=\"../xml/phpmyfaq.xml\" target=\"_blank\">XML File okay!</a></p>";
}


/******************************************************************************
 * Funktionen fr die Volltextsuche
 ******************************************************************************/

/*
 * Suchfunktion fr die Volltextsuche | @@ Thorsten - 2002-09-16
 * Last Update: @@ Thorsten, 2003-12-15
 */
function searchEngine($begriff)
{
	global $db, $sids, $msgEntries, $msgPage, $msgPages, $msgPrevious, $msgNext, $err_noArticles, $sqltblpre, $msgSearchAmount, $msgSearchAmounts, $msgVoteFrom, $msgSearchContent, $ubbcode;
	
	$categories = getCategories();
	$seite = "";
	$output = "";
	
	if (isset($_REQUEST["seite"])) {
		$seite = $_REQUEST["seite"];
		}
	if (isset($_REQUEST["search"])) {
		$begriff = $_REQUEST["search"];
		}
	$begriff = trim($begriff);
	
    if (mysql_check("4.0.1") == FALSE) {
        // Search with MySQL 3.23.23+
        $query = "SELECT id, lang, rubrik, thema, content FROM ".$sqltblpre."faqdata WHERE MATCH (thema,content,keywords) AGAINST ('".$begriff."') AND active = 'yes'";
        }
    else {
        // Search with MySQL 4.0.1+
        $query = "SELECT id, lang, rubrik, thema, content FROM ".$sqltblpre."faqdata WHERE MATCH (thema,content,keywords) AGAINST ('".str_replace(" ", "* ", trim($begriff))."*' IN BOOLEAN MODE) AND active = 'yes'";
        }
    
	$result = $db->query($query);
	$num = $db->num_rows($result);
	
    $seiten = ceil($num / 10);
	if (!$seite) {
		$seite = 1;
		}
	$y = $seite * 10; 
	$x = $y - 10;
	if ($y > $num) {
		$y = $num;
		}
	
    $result = $db->query($query." LIMIT ".$x.",10");
    
	if ($num > 0) {
		if ($num == "1") {
			$output .= "<p>".$num.$msgSearchAmount."</p>\n";
			}
		else {
			$output .= "<p>".$num.$msgSearchAmounts."</p>\n";
			}
		if ($seiten > 1) {
			$output .= "<p><b>".$msgPage.$seite." ".$msgVoteFrom." ".$seiten.$msgPages."</b></p>";
			}
		$output .= "<ul type=\"square\">\n";
	    for ($i = $x; $i < $y ; $i++) {
			list($id, $lang, $rubrik, $thema, $content) = $db->fetch_row($result);
			$rubriktext = $categories[$rubrik];
			$thema = substr($thema, 0, 45);
			if ($ubbcode == "true") {
				$content = parseUBB($content);
				}
			else {
				$content = stripslashes($content);
				}
			$content =  substr($content, 0, 80);
            $thema = preg_replace('/(((href|src)="[^"]*)?'.$begriff.'(?(1).*"))/umies', "highlight_no_links(\"\\1\")", $thema);
			$content = preg_replace('/(((href|src)="[^"]*)?'.$begriff.'(?(1).*"))/umies', "highlight_no_links(\"\\1\")", $content);
            $output .= "<li><b>".$rubriktext."</b>: <a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=artikel&amp;rubrik=".$rubrik."&amp;id=".$id."&amp;lang=".$lang."&amp;highlight=".$begriff."\">".stripslashes($thema)."...</a><br><div style=\"font-size: 10px;\"><b>".$msgSearchContent."</b> ".stripslashes($content)."...</div><br></li>\n";
            }
        $output .= "</ul>\n";
        }
    else {
		$output = $err_noArticles;
		}
    
    if ($num > 10) {
        $output .= "<p align=\"center\"><b>";
        $vor = $seite - 1; 
        $next = $seite + 1;
        if ($vor != 0) {
            $output .= "[ <a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=search&amp;&search=".$begriff."&amp;seite=".$vor."\">".$msgPrevious."</a> ]";
            }
        $output .= " ";
        if ($next <= $seiten) {
            $output .= "[ <a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=search&amp;search=".$begriff."&amp;seite=".$next."\">".$msgNext."</a> ]";
            }
        $output .= "</b></p>";
		}
	return $output;
}

/*
 * Funktion fr das Herausfiltern von highlighting HTML aus URLs und Images | @@ Matthias Sommerfeld, 2003-07-14
 * Last Update: @@ Thorsten, 2003-11-11
 */
function highlight_no_links($string = "")
{
    if ("" == $string) {
        return "";
        }
    if ("href=" == substr($string, 0, 5) || "src=" == substr($string, 0, 4)) {
        return $string;
    }
    else {
        return "<span style=\"color: #FF0000; border: 1px dotted #FF0000;\">".$string."</span>";
    }
}




/******************************************************************************
 * Funktionen fr die Offenen Fragen
 ******************************************************************************/

/*
 * Diese Funktion gibt die offenen Fragen aus | @@ Thorsten, 2002-09-17
 * Last Update: @@ Thorsten, 2003-04-17
 */
function printOpenQuestions()
{
	global $db, $sids, $sqltblpre, $msg2answer, $msgNoQuestionsAvailable;
	$categories = getCategories();
	
	$query = "SELECT id,ask_username,ask_usermail,ask_rubrik,ask_content,ask_date FROM ".$sqltblpre."faqfragen ORDER BY ask_date ASC";
	$result = $db->query($query);
	$output = "";
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
			$output .= "\t<tr class=\"openquestions\">\n";
			$output .= "\t\t<td valign=\"top\" nowrap>".makeDate($row->ask_date)."<br><a href=\"mailto:".safeEmail($row->ask_usermail)."\">".$row->ask_username."</a></td>\n";
			$output .= "\t\t<td valign=\"top\"><b>".$categories[$row->ask_rubrik].":</b><br>".stripslashes($row->ask_content)."</td>\n";
        	$output .= "\t\t<td valign=\"top\"><a href=\"".$_SERVER["PHP_SELF"]."?".$sids."aktion=add&amp;question=".rawurlencode($row->ask_content)."&amp;rubrik=".$row->ask_rubrik."\">".$msg2answer."</a></td>\n";
    		$output .= "\t</tr>\n";
			}
		}
	else {
		$output = "\t<tr>\n\t\t<td colspan=\"3\">".$msgNoQuestionsAvailable."</td>\n\t</tr>\n";
		}
	return $output;
}




/******************************************************************************
 * Funktionen fr die Benutzerauthentifozierung und Rechtevergabe
 ******************************************************************************/

/*
 * berprft die Rechte des Users bei einer bestimmten Aktion | @@ Bastian, 2001-02-18
 * Last Update: @@ Thorsten, 2003-10-02
 */
function Allowed($what, $user)
{
	global $db, $sqltblpre;
	list($rights, $what) = $db->fetch_row($db->query("SELECT ".$sqltblpre."faquser.rights, ".$sqltblpre."faqrights.id FROM ".$sqltblpre."faquser, ".$sqltblpre."faqrights WHERE ".$sqltblpre."faquser.ID = '".$user."' AND ".$sqltblpre."faqrights.SHORT = '".addslashes($what)."'"));
	for ($h = 1; $h <= strlen($rights); $h++) {
		$akt = substr($rights,($h-1), 1);
		if ($h == $what) {
			return $akt;
			}
		}
}

/*
 * Setzt die Rechte der User | @@ Bastian, 2001-02-18
 * Last Update: @@ Thorsten, 2003-10-02
 */
function GetRight($str)
{
    return $str;
}

/*
 * Logt den Admin | @@ Bastian, 2001-02-18
 * Last Update: @@ Thorsten, 2003-03-08
 */
function adminlog($text)
{
	global $db, $enableadminlog, $auth_user, $sqltblpre;
	if ($enableadminlog) {
		$db->query("INSERT INTO ".$sqltblpre."faqadminlog (ID,TIME,USER,TEXT,IP) VALUES ('','".time()."','".$auth_user."','".nl2br(addslashes($text))."','".$_SERVER["REMOTE_ADDR"]."')");
		}
}

/*
 * Zeigt User an, dass er keine Berechtigung hat. | @@ Bastian, 2001-02-18
 * Last Update: @@ Thorsten, 2002-09-19
 */
function na()
{
	global $err_NotAuth;
	print $err_NotAuth;
}

/*
 * Checkt, ob eine SQL-Tabelle leer ist | @@ Thorsten 2002-01-10
 * Last Update: @@ Thorsten, 2003-03-24
 */
function emptyTable($table)
{
	global $db;
	if ($db->num_rows($db->query("SELECT * FROM ".$table)) < 1) {
		return TRUE;
		}
	else {
		return FALSE;
		}
}



/******************************************************************************
 * Funktionen fr den Adminbereich
 ******************************************************************************/

/*
 * Funktion zum generieren vom "Umblttern" | @@ Bastian, 2002-01-03
 * Last Update: @@ Thorsten, 2002-12-18
 */
function PageSpan($code, $start, $end, $akt)
{
	global $msgPreviusPage, $msgLastPage, $msgPageDoublePoint, $msgNextPage;
	if ($akt > $start) {
		$out = str_replace("<NUM>", $akt-1, $code).$msgPreviusPage."</a> | ";
		}
	else {
		$out = "";
		}
	for ($h = $start; $h<=$end; $h++) {
		if($h > $start) {
			$out .= ", ";
			}
		if($h != $akt) {
			$out .= str_replace("<NUM>", $h, $code).$h."</a>";
			}
		else {
			$out .= $h;
			}
		}
	if ($akt < $end) {
		$out .= " | ".str_replace("<NUM>", $akt+1, $code).$msgNextPage."</a>";
		}
		$out = $msgPageDoublePoint.$out;
		return $out;
}

/*
 * Bastelt aus den Dateinamen des Tracking einen Timestamp | @@ Bastian, 2002-01-05
 * Last Update: @@ Thorsten, 2002-09-19
 */
function FileToDate($file)
{
	if (strlen($file) >= 16) {
		$tag = substr($file, 8, 2);
		$mon = substr($file, 10, 2);
		$yea = substr($file, 12, 4);
		$tim = mktime(1, 1, 1, $mon, $tag, $yea);
		return $tim;
		}
	else {
		return -1;
		}
}

/*
 * Funktion fuer das Wechseln des Tabellenhintergrunds | @@ Thorsten, 2001-04-10
 * Last Update: @@ Thorsten, 2002-09-19
 */
function rowcolor($zeile)
{
	if (($zeile/2) == floor($zeile/2)) {
		$retval = "#f5f5f5";
		}
	else {
		$retval = "#ffffff";
		}
	return $retval; 
}

/*
 * Bastelt nen Timestamp ausm Datum | @@ Bastian, 2001-04-09
 * Last Update: @@ Thorsten - 2002-09-27
 */
function mkts($datum,$zeit)
{
	if (strlen($datum) > 0) {
		$tag = substr($datum,0,strpos($datum,"."));
		$datum = substr($datum,(strpos($datum,".")+1),strlen($datum));
		$monat = substr($datum,0,strpos($datum,"."));
		$datum = substr($datum,(strpos($datum,".")+1),strlen($datum));
		$jahr = $datum;
	}
	else {
		$tag = date("d");
		$monat = date("m");
		$jahr = date("Y");
	}
	if (strlen($zeit) > 0) {
		$stunde = substr($zeit,0,strpos($zeit,":"));
		$zeit = substr($zeit,(strpos($zeit,":")+1),strlen($zeit));
		$minute = substr($zeit,0,strpos($zeit,":"));
		$zeit = substr($zeit,(strpos($zeit,":")+1),strlen($zeit));
		$sekunde = $zeit;
	}
	else {
		$stunde = date("H");
		$minute = date("i");
		$sekunde = date("s");
	}
	return mktime($stunde, $minute, $sekunde, $monat, $tag, $jahr);
}

// Hinweis: Die folgende Funktion muss weg, wenn Nested Sets kommen!
/*
 * Fgt eine Kategorie hinzu | @@ Bastian - 2002-01-29
 * Last Update: @@ Thorsten, 2003-03-06
 */
function AddCategory($TopCategory, $Titel)
{
	global $db, $sqltblpre;
	
	$datum = date("YmdHis");
	$result = $db->query("SELECT rubrik FROM ".$sqltblpre."faqrubrik WHERE LEFT(rubrik, ".strlen($TopCategory).") = '".$TopCategory."' AND LENGTH(rubrik) = ".(strlen($TopCategory)+3));
	$max = 0;
	while(list($rub) = $db->fetch_row($result)) {
		if( substr($rub, strlen($rub)-3, 3) > $max) {
			$max = substr($rub, strlen($rub)-3, 3);
			}
		}
	$max++;
	while(strlen($max) < 3) {
		$max = "0".$max;
		}
	$TopCategory .= $max;
	$db->query("INSERT INTO ".$sqltblpre."faqrubrik (rubrik, titel, datum) VALUES ('".$TopCategory."', '".$Titel."', '".$datum."')");
	return $TopCategory;
}

/*
 * Funktion fr Umwandlung der Rubriknamen | @@ Thorsten, 2003-03-21
 * Last Update: @@ Thorsten, 2003-03-21
 */
function getCategories()
{
	global $db, $no_cats, $sqltblpre;
	$result = $db->query("SELECT rubrik, titel FROM ".$sqltblpre."faqrubrik ORDER by rubrik");
	if ($db->num_rows($result) > 0) {
		while ($row = $db->fetch_object($result)) {
			$output[$row->rubrik] = strip_tags($row->titel);
			}
		}
	else {
		$output[] = $no_cats;
		}
	return $output;
}

/*
 * Funktion fr das Setzen der Hintergrundfarbe der Admin-Navigation | @@ Thorsten, 2003-04-17
 * Last Update: @@ Thorsten, 2003-04-17
 */
function adminColor($site)
{
	if ($site == $_REQUEST["aktion"]) {
		return "#f5f5f5";
		}
	else {
		return "#b0c4de";
		}
}



/******************************************************************************
 * Funktionen fr das Backup
 ******************************************************************************/

/*
 * Funktion zum Zusammensetzen der zu sichernden SQL Queries | @@ Meikel, 2003-03-24
 * Last Update: @@ Thorsten, 2003-11-13
 */
function build_insert ($query, $table)
{
	global $db;
	if (!$result = $db->query($query)) {
		return;
		}
	$ret = array();
	$ret[] = "\n# Table: ".$table;
	while ($row = $db->fetch_assoc ($result)) {
		$p1 = array();
		$p2 = array();
		foreach ($row as $key => $val) {
            $val = safeSQL($val);
			$p1[] = $key;
			$p2[] = "'".$val."'";
			}
		$ret[] = "INSERT INTO ".$table." (".implode(",", $p1).") VALUES (".implode(",", $p2).");";
		}
	return $ret;
}

/*
 * Funktion zum Escapen von SQL Queries | @@ Thorsten, 2003-11-13
 * Last Update: @@ Thorsten, 2003-11-18
 */
function safeSQL($string)
{
    $str = "";
    $length = strlen($string);
    for ($i = 0; $i < $length; $i++) {
        $char = $string[$i];
        switch ($char) {
            case "'":           $str .= "\'";
                                break;
            case "\\":          $str .= "\\\\";
                                break;
            case "\n":          $str .= "\\n";
                                break;
            case "\r":          $str .= "\\r";
                                break;
            default:            $str .= $char;
            }
        }
    return $str;
}


/******************************************************************************
 * Verschiedene Funktionen
 ******************************************************************************/

/*
 * Funktion fr das interne Linking | @@ Nick Georgakis, 2003-08-25
 * Last Update: @@ Thorsten, 2003-11-18
 */
function internalLink ($output) {
    global $db, $sqltblpre, $no_cats;
    if (sizeof($output) != 3) {
        return "<i><b>Article Link Error.</b></i>";
        }
   if (isset($_REQUEST["sid"])) {
        $thsids = "sid=".$_REQUEST["sid"]."&amp;";   
        }
    else {
        $thsids = "";
    }
    
    $query = "SELECT ".$sqltblpre."faqdata.thema,".$sqltblpre."faqdata.rubrik FROM ".$sqltblpre."faqdata WHERE id = '".$output[1]."' AND lang = '".$output[2]."'";
    
    $result = $db->query($query);
    
    if ($db->num_rows($result) > 0) {
        while ($row = $db->fetch_object($result)) {
            return "<a href=\"".$_SERVER["PHP_SELF"]."?".$thsids."aktion=artikel&amp;rubrik=".$row->rubrik."&amp;id=".$output[1]."&amp;lang=".$output[2]."\">".stripslashes($row->thema)."</a>";
            }
        }
    else {
        return "<i><b>Article not found</b></i>";
        }
    }

/*
 * Funktion fr Versioncheck | @@ Thorsten, 2003-10-10
 * Last Update: @@ Thorsten, 2003-10-10
 */
function version_check ($ist = "", $soll = "", $err_msg = "")
{
    if (empty($ist) OR empty($soll)) {
        return FALSE;
        }
    $ist = explode(".", $ist);
    $soll = explode(".", $soll);
    for ($i = 0; $i < count($soll); $i++) {
        if ($ist[$i] <  $soll[$i]) {
            return FALSE;
            }
        if ($ist[$i] == $soll[$i]) {
            continue;
            }
        if ($ist[$i] >= $soll[$i]) {
            return TRUE;
            }
        }
    return TRUE;
}



/*
 * Funktion fr MySQL-Versioncheck | @@ Thorsten, 2003-10-10
 * Last Update: @@ Thorsten, 2003-10-10
 */
function mysql_check($version)
{
    return version_check (mysql_get_server_info(), $version);
}
?>