<?php
/*
 * FAQ FRENZY
 * admin.php - Administrative Functions
 * Version 1.0, 15-Jan-04
 * Copyright 2003,2004 Ross W. Poulton
 * ross@rossp.org
 * http://www.rossp.org/
 * 
 * This file is part of FAQ Frenzy.
 *
 * FAQ Frenzy is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * FAQ Frenzy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

$myEnv["module"] = "faqfrenzy";
$myEnv["output"] = "html";
                                                                                
require_once("../../config.inc.php");
require_once(INCLUDEPATH . "container.inc.php");
                                                                                
// adding file revision into global array
revisionInit("\$Revision: 1.3 $", __FILE__);
                                                                                
/* Include Common Functions */
require_once "inc/setup.inc.php";

/* Retrive our action variable from a POST or GET, giving
   priority to POST */
$a = isset($_POST['a']) ? $_POST['a'] : (isset($_GET['a'])?$_GET['a']:"front");

if (!queryRights2_bool('root_modules_faqfrenzy_admin')) {
    $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
    $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
    $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
    exit();
}

if ($a == 'front') {
	/* Front screen - give the user a quick menu */
	$smarty->display('faqfrenzy_admin_front.tpl');
} elseif ($a == 'addcatform' || $a == 'editcatform') {
	$catid = 0;
	if ($a == 'editcatform') {
	   $catid = $conn->QMagic((int)$_POST['catid']);
	}

	$sql = "SELECT * FROM mgw_faqfrenzy_categories WHERE catid = $catid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$row = $res->FetchRow();

	include_once(INCLUDEPATH . "mSelectBox.class.php");
	$sql="SELECT * FROM mgw_faqfrenzy_categories ORDER BY cattitle";
	$sb = new mSelectBox("catparent",$row["catparent"]);
	$sb->setContentType("sql");
	$sb->setSQLvalue("catid");
	$sb->setSQLcontent("cattitle");
	$sb->addContent($sql);
	$sb->addOption("0", Lang::getLanguageString("Home"), "pre");
	$sb->addOption("", "", "pre");
	$smarty->assign('categorysb',$sb->draw());
	$smarty->assign('catentry',$row);
	$smarty->assign('catform',$a);
	$smarty->display('faqfrenzy_admin_catform.tpl');

} elseif ($a == 'editcatselect') {
	include_once(INCLUDEPATH . "mSelectBox.class.php");
	$sql = "SELECT * FROM mgw_faqfrenzy_categories ORDER BY catid";
	$sb = new mSelectBox("catid");
	$sb->setContentType("sql");
	$sb->setSQLvalue("catid");
	$sb->setSQLcontent("cattitle");
	$sb->addContent($sql);
	$smarty->assign('categorysb',$sb->draw());
	$smarty->display('faqfrenzy_admin_editcatselect.tpl');

} elseif ($a == 'delcatselect') {

	$sql = "SELECT DISTINCT catid FROM mgw_faqfrenzy_questions";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
                                                                                
        $used_catids_arr = array();
        while ($row = $res->FetchRow()) {
               $used_catids_arr[]=$row["catid"];
        }
	$used_catids = implode(",", $used_catids_arr);
	$where="";
	if (!empty($used_catids)) {
	   $where = "WHERE catid NOT IN ($used_catids)";
	}

	include_once(INCLUDEPATH . "mSelectBox.class.php");
	$number_empty_cats=$conn->GetOne("SELECT COUNT(*) FROM mgw_faqfrenzy_categories $where ORDER BY catid");
	$sql = "SELECT * FROM mgw_faqfrenzy_categories $where ORDER BY catid";
	$sb = new mSelectBox("catid");
	$sb->setContentType("sql");
	$sb->setSQLvalue("catid");
	$sb->setSQLcontent("cattitle");
	$sb->addContent($sql);
	$smarty->assign('number_empty_cats',$number_empty_cats);
	$smarty->assign('categorysb',$sb->draw());
	$smarty->display('faqfrenzy_admin_delcatselect.tpl');

} elseif ($a == 'delfaqselect' || $a == 'editfaqselect') {
	/* Display a form to allow the user to select an FAQ
	   to delete */

	$sql = "SELECT * FROM mgw_faqfrenzy_questions ORDER BY faqid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	$faqs=array();
        while ($row = $res->FetchRow()) {
            $faqs[]=$row;
	}
	$smarty->assign('faqs',$faqs);
	$smarty->assign('faqselect',$a);
	$smarty->display('faqfrenzy_admin_faqselect.tpl');

} elseif ($a == 'addfaqform' || $a == 'editfaqform') {
	/* Based on the users previous selection of an FAQ entry, lets display 
	   it to them for editing. */

	/* Sanitise for the database */
	$faqid = 0;
	if ($a == 'editfaqform') {
	   $faqid = $conn->QMagic((int)$_REQUEST['faqid']);
	}

	$sql = "SELECT * FROM mgw_faqfrenzy_questions WHERE faqid = $faqid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$row = $res->FetchRow();

        include_once(INCLUDEPATH . "mSelectBox.class.php");
        $sql="SELECT * FROM mgw_faqfrenzy_categories ORDER BY cattitle";
        $sb = new mSelectBox("catid",$row["catid"]);
        $sb->setContentType("sql");
        $sb->setSQLvalue("catid");
        $sb->setSQLcontent("cattitle");
        $sb->addContent($sql);
        $sb->addOption("0", Lang::getLanguageString("Home"), "pre");
        $sb->addOption("", "", "pre");
                                                                                
        $smarty->assign('faqentry',$row);
        $smarty->assign('faqform',$a);
        $smarty->assign('categorysb',$sb->draw());
        $smarty->display('faqfrenzy_admin_faqform.tpl');

} elseif ($a == 'addrelationshipform') {

	$sql = "SELECT * FROM mgw_faqfrenzy_questions ORDER BY faqid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	$faqs=array();
        while ($row = $res->FetchRow()) {
            $faqs[]=$row;
	}
	$smarty->assign('faqs',$faqs);
	$smarty->display('faqfrenzy_admin_addrelationshipform.tpl');

} elseif ($a == 'procdelcat') {
	$catid = $conn->QMagic((int)$_POST['catid']);
	$sql = "DELETE FROM mgw_faqfrenzy_categories WHERE catid = $catid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	redirect('admin.php?'.SID);

} elseif ($a == 'procnewcat' || $a == 'proceditcat') {

	/* Process the users input to add a new category to 
	   the system. */

	if ($a == 'proceditcat') {
	    $catid = (int)$_POST['catid'];
	}
	$cattitle = $conn->QMagic($_POST['cattitle']);
	$catparent = $conn->QMagic($_POST['catparent']);
	if ($a == 'procnewcat') {
	   $sql = "INSERT INTO mgw_faqfrenzy_categories (cattitle,
		catparent) VALUES ($cattitle, $catparent)";
	} else {
	   $sql = "UPDATE mgw_faqfrenzy_categories SET cattitle=$cattitle, catparent=$catparent WHERE catid = $catid";
	}
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	redirect('admin.php?'.SID);

} elseif ($a == 'procdelfaq') {
	/* Delete an FAQ $faqid if $confirm = 'true' */

	$faqid = $conn->QMagic((int)$_POST['faqid']);
	$sql = "DELETE FROM mgw_faqfrenzy_questions WHERE faqid = $faqid";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$sql = "DELETE FROM mgw_faqfrenzy_relationships WHERE relfaqid1 = $faqid OR relfaqid2 = $faqid ";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	redirect('admin.php?a=delfaqselect&'.SID);

} elseif ($a == 'procnewfaq' || $a == 'proceditfaq') {
	/* Process the users input to add a new FAQ to the system. */

	/* Sanitise data */
	$catid = (int)$_POST['catid'];
	$faqtitle = $conn->QMagic($_POST['faqtitle']);
	$faqdescription = $conn->QMagic($_POST['faqdescription']);
	$faqsolution = $conn->QMagic($_POST['faqsolution']);
	$faqkeywords = $conn->QMagic($_POST['faqkeywords']);
	$faqlastupdate = time();
	if ($a == 'proceditfaq') {
	    $faqid = (int)$_POST['faqid'];
	}

	/* Execute database query */
	if ($a == 'procnewfaq') {
	   $sql = "INSERT INTO mgw_faqfrenzy_questions (catid, faqtitle,
		faqdescription, faqsolution, faqkeywords, faqlastupdate) VALUES
		($catid, $faqtitle, $faqdescription, $faqsolution, 
		$faqkeywords, $faqlastupdate)";
	} else {
	    $sql = "UPDATE mgw_faqfrenzy_questions SET
		catid=$catid,
		faqtitle=$faqtitle,
		faqdescription=$faqdescription,
		faqsolution=$faqsolution,
		faqkeywords=$faqkeywords,
		faqlastupdate=$faqlastupdate
		WHERE faqid = $faqid";
	}
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	redirect('admin.php?'.SID);

} elseif ($a == 'procaddrel') {
        /* Process the users input to add an FAQ relationship */
                                                                                
        $faqid1 = (int)$_POST['faqid1'];
        $faqid2 = (int)$_POST['faqid2'];
                                                                                
        $sql = "INSERT INTO mgw_faqfrenzy_relationships (relfaqid1, relfaqid2) VALUES ($faqid1, $faqid2)";
	if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	redirect('admin.php?'.SID);
}

?>
